package com.googlecode.mad.mvntools.settingsutil.filestore;

import java.io.File;
import java.util.TreeMap;

/**
 * - Apache License 2.0 - <br>
 * Mojo to back up the Files in a x.xml-file <br>
 * <br>
 * LastChangedBy: $Author: marthaler.worb@gmail.com $<br>
 * LastChangedDate: $Date: 2010-12-29 14:23:06 +0100 (Mi, 29 Dez 2010) $
 * 
 * @author daniel marthaler
 * @version $Revision: 22 $
 * @since 24.12.2010
 * @goal backup
 */
public class BackupFilestore extends AbstractFilestore {
    
    public BackupFilestore() {
        super();
        this.fileName = "SettingsUtil:backup";
    }
    
    @Override
    @SuppressWarnings("unchecked")
    protected void myExecute() {
        
        TreeMap<String, TreeMap<String, String>> myMap = new TreeMap<String, TreeMap<String, String>>();
        
        String temp = null;
        
        temp = this.fileUtil.loadFile(this.getRootPath() + this.backupFile);
        
        if ((temp != null) && (temp.length() > 0)) {
            try {
                myMap = (TreeMap<String, TreeMap<String, String>>) this.xstream.fromXML(temp);
            } catch (final Exception e) {
                this.getLog().debug("unmarshaling not possible");
            }
        }
        
        TreeMap<String, String> files = myMap.get(this.name);
        if (files == null) {
            files = new TreeMap<String, String>();
        }
        
        for (final String string : this.files) {
            files.put(AbstractFilestore.FILE + string, this.fileUtil.loadFile(this.getRootPath() + string));
        }
        
        for (final String string : this.folders) {
            
            final File folder = new File(this.getRootPath() + string);
            if (folder.exists() && folder.isDirectory()) {
                final String[] ff = folder.list();
                for (final String theFile : ff) {
                    files.put(AbstractFilestore.FOLDER + string + this.delimiter + theFile, this.fileUtil.loadFile(this.getRootPath() + string + this.delimiter + theFile));
                }
            }
            
        }
        
        myMap.put(this.name, files);
        
        this.fileUtil.replaceFileWithNewContent(this.getRootPath() + this.backupFile, this.xstream.toXML(myMap));
        
    }
}
