package com.googlecode.mad.mvntools.settingsutil.filestore;

import java.util.Set;
import java.util.TreeMap;

/**
 * - Apache License 2.0 - <br>
 * Mojo to back up the Files in a x.xml-file: rename a user <br>
 * <br>
 * LastChangedBy: $Author: marthaler.worb@gmail.com $<br>
 * LastChangedDate: $Date: 2010-12-29 14:14:06 +0100 (Wed, 29 Dec 2010) $
 * 
 * @author daniel marthaler
 * @version $Revision: 21 $
 * @since 19.01.2011
 * @goal list
 */
public class DeleteNameFilestore extends AbstractFilestore {
    
    public DeleteNameFilestore() {
        super();
        this.fileName = "SettingsUtil:rename";
    }
    
    @Override
    @SuppressWarnings("unchecked")
    protected void myExecute() {
        
        TreeMap<String, TreeMap<String, String>> myMap = null;
        
        String temp = null;
        
        temp = this.fileUtil.loadFile(this.getRootPath() + this.backupFile);
        
        if ((temp != null) && (temp.length() > 0)) {
            try {
                myMap = (TreeMap<String, TreeMap<String, String>>) this.xstream.fromXML(temp);
            } catch (final Exception e) {
                this.getLog().debug("unmarshaling not possible");
            }
        }
        
        final Set<String> keys = myMap.keySet();
        
        this.getLog().info("settingsutil containig the names: ");
        for (final String string : keys) {
            this.getLog().info("-> " + string);
        }
    }
}
