package com.googlecode.mad.mvntools.settingsutil.filestore;

import java.util.TreeMap;

/**
 * - Apache License 2.0 - <br>
 * Mojo to back up the Files in a x.xml-file: rename a user <br>
 * <br>
 * LastChangedBy: $Author: marthaler.worb@gmail.com $<br>
 * LastChangedDate: $Date: 2010-12-29 14:14:06 +0100 (Wed, 29 Dec 2010) $
 * 
 * @author daniel marthaler
 * @version $Revision: 21 $
 * @since 19.01.2011
 * @goal deletename
 */
public class ListnamesFilestore extends AbstractFilestore {
    
    public ListnamesFilestore() {
        super();
        this.fileName = "SettingsUtil:rename";
    }
    
    @Override
    @SuppressWarnings("unchecked")
    protected void myExecute() {
        
        TreeMap<String, TreeMap<String, String>> myMap = null;
        
        String temp = null;
        
        temp = this.fileUtil.loadFile(this.getRootPath() + this.backupFile);
        
        if ((temp != null) && (temp.length() > 0)) {
            try {
                myMap = (TreeMap<String, TreeMap<String, String>>) this.xstream.fromXML(temp);
            } catch (final Exception e) {
                this.getLog().debug("unmarshaling not possible");
            }
        }
        
        if (!myMap.containsKey(this.name)) {
            this.getLog().error("name: " + this.name + " not found, coluld not delete");
            return;
        }
        
        final TreeMap<String, String> files = myMap.remove(this.name);
        
        this.fileUtil.replaceFileWithNewContent(this.getRootPath() + this.backupFile, this.xstream.toXML(myMap));
    }
}
