package com.googlecode.mad.mvntools.settingsutil.filestore;

import java.io.File;
import java.util.TreeMap;

/**
 * - Apache License 2.0 - <br>
 * Mojo to back up the Files in a x.xml-file <br>
 * <br>
 * LastChangedBy: $Author: marthaler.worb@gmail.com $<br>
 * LastChangedDate: $Date: 2011-01-19 21:28:59 +0100 (Mi, 19 Jan 2011) $
 * 
 * @author daniel marthaler
 * @version $Revision: 28 $
 * @since 26.06.2010
 * @goal restore
 */
public class RestoreFilestore extends AbstractFilestore {
    
    public RestoreFilestore() {
        super();
        this.fileName = "SettingsUtil:restore";
    }
    
    @Override
    @SuppressWarnings("unchecked")
    protected void myExecute() {
        
        TreeMap<String, TreeMap<String, String>> myMap = null;
        
        String temp = null;
        
        temp = this.fileUtil.loadFile(this.getRootPath() + this.backupFile);
        
        if ((temp != null) && (temp.length() > 0)) {
            try {
                myMap = (TreeMap<String, TreeMap<String, String>>) this.xstream.fromXML(temp);
            } catch (final Exception e) {
                this.getLog().debug("unmarshaling not possible");
            }
        }
        
        TreeMap<String, String> files = myMap.get(this.name);
        if (files == null) {
            files = new TreeMap<String, String>();
        }
        
        for (final String string : files.keySet()) {
            if (string.startsWith(AbstractFilestore.FILE)) {
                this.fileUtil.replaceFileWithNewContent(this.getRootPath() + this.delimiter + string.replace(AbstractFilestore.FILE, AbstractFilestore.EMTYSTRING), files.get(string));
            }
        }
        this.extractFolders(files);
    }
    
    /**
     * @param files
     */
    private void extractFolders(final TreeMap<String, String> files) {
        boolean folderok = false;
        for (final String string : files.keySet()) {
            if (string.startsWith(AbstractFilestore.FOLDER)) {
                
                if (!folderok) {
                    final String ftemp = string.replace(AbstractFilestore.FOLDER, AbstractFilestore.EMTYSTRING);
                    final String folderOnly = ftemp.substring(0, ftemp.indexOf(this.delimiter));
                    final File folder = new File(this.getRootPath() + folderOnly);
                    if (!folder.exists()) {
                        folder.mkdir();
                        folderok = true;
                    }
                }
                this.fileUtil.replaceFileWithNewContent(this.getRootPath() + this.delimiter + string.replace(AbstractFilestore.FOLDER, AbstractFilestore.EMTYSTRING), files.get(string));
            }
        }
    }
}
